#!/usr/bin/perl -wT
#
# The contents of this file are subject to the Mozilla Public
# License Version 1.1 (the "License"); you may not use this file
# except in compliance with the License. You may obtain a copy of
# the License at http://www.mozilla.org/MPL/
#
# Software distributed under the License is distributed on an "AS
# IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
# implied. See the License for the specific language governing
# rights and limitations under the License.
#
# The Original Code is the Bugzilla Bug Tracking System.
# 
# The Initial Developer of the Original Code is Netscape Communications
# Corporation. Portions created by Netscape are Copyright (C) 1998
# Netscape Communications Corporation. All Rights Reserved.
#
# Contributor(s): Alexey Gladkov <legion@altlinux.org>

use diagnostics;
use strict;
use lib ".";

require "CGI.pl";

use vars qw(
	@legal_product
	$buffer
    $template
    $vars
);

ConnectToDatabase();

if (defined $::FORM{"GoAheadAndLogIn"}) {
    # We got here from a login page, probably from relogin.cgi.  We better
    # make sure the password is legit.
    confirm_login();
} else {
    quietly_check_login();
}

GetVersionTable(); 

if (!defined $::FORM{'product'}) {
  my @products;

  foreach my $p (@::legal_product) {
	next if (Param("usebuggroups") && GroupExists($p) && !UserInGroup($p));
    push @products,$p;
  }
 
  my $prodsize = scalar(@products);
  if ($prodsize == 0) {
      DisplayError("Either no products have been defined to enter bugs ".
                     "against or you have not been given access to any.\n");
      exit;
  } 
  elsif ($prodsize > 1) {
    $vars->{'prod'} = \@products;
	$vars->{'cur_tab_name'} = "ssearch";
    $vars->{'target'} = "simple_query.cgi";
        
	print "Content-type: text/html\n\n";
    $template->process("search/simple-search.html.tmpl", $vars)
          || ThrowTemplateError($template->error());
    exit;        
  }

}

sub GetQuery {
  my ($sqlfield,$matchtype,$matchstr) = @_;
  
  my $query = "";
  if ($matchtype eq 'substr') {
    $query .= " AND " . $sqlfield . " LIKE ";
    $matchstr = '%' . $matchstr . '%';
  } elsif ($matchtype eq 'regexp') {
    $query .= " AND " . $sqlfield . " REGEXP ";
    $matchstr = '.'
      unless $matchstr;
  } elsif ($matchtype eq 'notregexp') {
    $query .= " AND " . $sqlfield . " NOT REGEXP ";
    $matchstr = '.'
      unless $matchstr;
  } 
  $query .= SqlQuote($matchstr);
  return $query;
}

my $product = SqlQuote($::FORM{'product'});
my $component = $::FORM{'component_str'} ? $::FORM{'component_str'} : ".*";

my $SQLwhere = GetQuery("value",$::FORM{'component_type'},$component);
SendSQL("SELECT value FROM components WHERE program=".$product.$SQLwhere);

my $query="";
while (MoreSQLData()) {
  my ($comp_value) = FetchSQLData();
  $query.="&component=".$comp_value;
}

# We add to buffer our results. 
$::buffer.=$query;

do 'buglist.cgi';

